package org.diagbot.push.controller;

import org.diagbot.common.push.bean.FeatureRate;
import org.diagbot.common.push.bean.ResponseData;
import org.diagbot.common.push.bean.SearchData;
import org.diagbot.pub.api.Response;
import org.diagbot.pub.utils.http.HttpApi;
import org.diagbot.pub.web.BaseController;
import org.diagbot.push.model.GraphDiseaseParamModel;
import org.diagbot.push.model.GraphDiseaseResultModel;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by louhr on 2020/2/25.
 */
@Controller
@RequestMapping("/algorithm_validate")
public class AlgorithmValidateController extends BaseController {
    {
        listView = "/pages/validate/list.html";
    }

    @RequestMapping({ "/index" })
    public String index() {
        return listView;
    }

    @RequestMapping(value = "/page_neural")
    @ResponseBody
    public Response<ResponseData> neuralData(HttpServletRequest request, SearchData searchData) throws Exception {
        return combine(request, searchData);
    }

    @RequestMapping(value = "/neural", method = RequestMethod.POST)
    @ResponseBody
    public Response<ResponseData> bayesPageData(HttpServletRequest request, @RequestBody SearchData searchData) throws Exception {
        return combine(request, searchData);
    }

    public Response<ResponseData> combine(HttpServletRequest request, @RequestBody SearchData searchData) throws Exception {
        Response<ResponseData> response = new Response();
        ResponseData responseData = new ResponseData();

        GraphDiseaseParamModel paramModel = new GraphDiseaseParamModel();
        paramModel.setQuery(searchData.getSymptom());
        HttpApi<GraphDiseaseResultModel> httpApi = new HttpApi<>();
        GraphDiseaseResultModel resultModel = httpApi.doPost("http://192.168.3.150:2222/api/inference_disease_graph", paramModel, GraphDiseaseResultModel.class);
        if (resultModel.getDiseases() != null && resultModel.getDiseases().length > 0) {
            List<FeatureRate> dis = new ArrayList<>(10);
            int num = 0;
            for (String s : resultModel.getDiseases()) {
                FeatureRate featureRate = new FeatureRate();
                featureRate.setFeatureName(s);
                dis.add(featureRate);
                num++;
                if (num > searchData.getLength()) {
                    break;
                }
            }
            responseData.setDis(dis);
        }
        response.setData(responseData);
        return response;
    }
}
